#include "mainwindow.h"
#include "ui_mainwindow.h"


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);  
    ui->label->setText(tr("Language"));
    m_Translator = new QTranslator(this);

    qInfo() << "font  = " << qApp->font();
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_actiona_chinese_triggered()
{
    //set global font
    QFont font("Noto Sans CJK SC");
    QApplication::setFont(font);

    //load translate file
    m_Translator->load("../language/Translate_CN.qm");

    //the Demo
    QTextLayout layout;
    layout.setText("Visual Studio Code");
    QFixed wf = 55;
    auto eg = layout.engine();
    const QString &end_str = eg->elidedText(Qt::ElideLeft, wf, Qt::AlignCenter, 7);

    //correct end_str is "… Code"
    //wrong end_str is "io Code"
    ui->lineEdit->setText(end_str);

    ui->retranslateUi(this);
}

void MainWindow::on_actionb_English_triggered()
{
    //load translate file
    m_Translator->load("../language/Translate_EN.qm");
    qApp->installTranslator(m_Translator);

    //the Demo
    QTextLayout layout;
    layout.setText("Visual Studio Code");
    QFixed wf = 55;
    auto eg = layout.engine();
    const QString &end_str = eg->elidedText(Qt::ElideLeft, wf, Qt::AlignCenter, 7);

    //correct end_str is "… Code"
    //wrong end_str is "io Code"
    ui->lineEdit->setText(end_str);

    ui->retranslateUi(this);
}

void MainWindow::on_actionc_Tibetan_triggered()
{
    //set global font
    QFont font("Noto Sans Tibetan");
    QApplication::setFont(font);

    //load translate file
    m_Translator->load("../language/Translate_TB.qm");
    qApp->installTranslator(m_Translator);

    //the Demo
    QTextLayout layout;
    layout.setText("Visual Studio Code");
    QFixed wf = 55;
    auto eg = layout.engine();
    const QString &end_str = eg->elidedText(Qt::ElideLeft, wf, Qt::AlignCenter, 7);

    //correct end_str is "… Code"
    //wrong end_str is "io Code"
    ui->lineEdit->setText(end_str);

    ui->retranslateUi(this);
}
